//----------------------------------------------------------------------------
//Borland C++Builder
//Copyright (c) 1987, 1998 Borland International Inc. All Rights Reserved.
//----------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <windows.h>
#include "SOSCmain.h"
#include "math.h"
#include <stdlib.h>
#include <stdio.h>  //  sprintf
#include <mmsystem.h>   // timeGetTime()

#define VERSION "0.25"
#define Lite

#define ON  1
#define OFF 0
#define OK  0
#define NG -1

#define CUT_TM         300	// 300[mS]  ʐMՒfo
#define TX_TIM         100	// 100[mS]  ݒl̑MԊu

#define DEF_COL_CH1Pen  clYellow
#define DEF_COL_CH2Pen  clAqua
#define DEF_COL_Body    ((TColor)0x99D9DB)	// clBtnFace;
#define DEF_COL_Knob    ((TColor)0xb1cdbd)	// clBtnFace
#define DEF_COL_Bezel   ((TColor)0xff8080)	// clBtnFace
#define DEF_COL_Screen  ((TColor)0x400000)	// clGray
#define DEF_COL_Grid    ((TColor)0x000080)	// clMaroon



//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}






//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
#if defined (Lite)
	Form1->Caption = " SOSC Lite Ver." VERSION;
    L_CH1_RANGE -> Visible = false;
    L_CH2_RANGE -> Visible = false;
    CB_RNG1     -> Visible = false;
    CB_RNG2     -> Visible = false;
    CB_ACC1     -> Visible = false;
    CB_ACC2     -> Visible = false;

    PB_Z1 -> Top = 20;  PB_Z1 -> Left = 35;
    PB_Z2 -> Top = 20;  PB_Z2 -> Left = 35;
#else
	Form1->Caption = " SOSC Ver." VERSION;
#endif

	DefPath  = ExtractFileDir(Application->ExeName);
	IniPath  = ChangeFileExt (Application->ExeName, ".ini");

	ReadIniFile(IniPath);
	SetComPortName(ComboBox1);
	InitComPort(false);

    SetColor();
	ClrScreen();
    CreateFlag = true;
}




//---------------------------------------------------------------------------
//@IitH[ꂽAĂяoj
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	WriteIniFile(IniPath, 1);		// Commݒ
}


//---------------------------------------------------------------------------
// L|[g擾 ComboBox1ɓo^
//---------------------------------------------------------------------------
void __fastcall TForm1::SetComPortName(TComboBox *p)
{
	char name[10];
	int i;

	p->Items->Clear();
	for (i = 1; i <= 20; i++) {
	    sprintf(name, "COM%d", i);
	    if (Ycom.IsValidComName(name) == true) p->Items->Add(name);
	}

}
//---------------------------------------------------------------------------
// bnl|[g̏
//---------------------------------------------------------------------------
void __fastcall TForm1::InitComPort(bool msgflag)
{
	bool success;

	Ycom.sio_close();
	Ycom.SetComName       (ComboBox1->Text.c_str());
	Ycom.SetComBaudRateStr(CB_Br1->Text.c_str());
	Ycom.SetComByteSizeStr("8");
	Ycom.SetComParityStr  ("NONE");
	Ycom.SetComStopBitsStr("1");
	Ycom.SetComTxXflow    (false);
	Ycom.SetComRxXflow    (false);
	Ycom.SetComXonChar    (0x11);
	Ycom.SetComXoffChar   (0x13);

	success = Ycom.sio_open();
	if (success == false) msgflag = true;

	if (msgflag == true) {
	    MessageBeep(0);
	    if (success == true) ShowMessage("@bnl|[g nj@");
	    else                 ShowMessage("@bnl|[g mf@");
	}
}




//---------------------------------------------------------------------------
// ini t@C̓ǂݍ
//---------------------------------------------------------------------------
void __fastcall TForm1::ReadIniFile(AnsiString path)
{
	TIniFile *iniFile;
	TFontStyles style;
	int left,top;

	iniFile = new TIniFile(path);

	left   = iniFile->ReadInteger("Position" , "Left"  , 0);
	top    = iniFile->ReadInteger("Position" , "Top"   , 0);
	CB_SNAP->Checked = iniFile->ReadBool("Position", "Snap", false);
	if  ((left > Screen->Width  - 65)
	  || (top  > Screen->Height - 65)) {
	    Form1->Position = poScreenCenter;
	}
	if (left < 0) left = 0;
	if (top  < 0) top  = 0;
	Form1->Left   = left;  Form1->Top    = top;

	ComboBox1 -> Text = iniFile->ReadString("CommPort", "PortNo" , "COM1"  );
	CB_Br1    -> Text = iniFile->ReadString("CommPort", "Baud"   , "57600" );
	CB_TMDIV  -> ItemIndex = iniFile->ReadInteger("Panel_Setting", "TM_Div"      , 2);
	CB_VMODE  -> ItemIndex = iniFile->ReadInteger("Panel_Setting", "V-Mode"    ,   0);
	CB_TRG_CH -> ItemIndex = iniFile->ReadInteger("Panel_Setting", "Trig_Channel", 0);
	CB_TRG_MD -> ItemIndex = iniFile->ReadInteger("Panel_Setting", "Trig_Mode"   , 0);
	CB_TRG_EG -> ItemIndex = iniFile->ReadInteger("Panel_Setting", "Trig_Edge"   , 0);
	TB_TRGL   -> Position  = iniFile->ReadInteger("Panel_Setting", "Trig_Level"  , TB_TRGL->Max/2);
	CB_RNG1   -> ItemIndex = iniFile->ReadInteger("Panel_Setting", "CH1_Range"   , 4);
	CB_RNG2   -> ItemIndex = iniFile->ReadInteger("Panel_Setting", "CH2_Range"   , 4);
	TB_OFS1   -> Position  = iniFile->ReadInteger("Panel_Setting", "CH1_Position", TB_OFS1->Max/2);
	TB_OFS2   -> Position  = iniFile->ReadInteger("Panel_Setting", "CH2_Position", TB_OFS2->Max/2);
	TB_GAIN1  -> Position  = iniFile->ReadInteger("Panel_Setting", "CH1_Gain"    , TB_GAIN1->Max );
	TB_GAIN2  -> Position  = iniFile->ReadInteger("Panel_Setting", "CH2_Gain"    , TB_GAIN2->Max );

	Col_CH1Pen  = (TColor)iniFile->ReadInteger("Color", "Color_CH1Pen", DEF_COL_CH1Pen);
	Col_CH2Pen  = (TColor)iniFile->ReadInteger("Color", "Color_CH2Pen", DEF_COL_CH2Pen);
	Col_Body    = (TColor)iniFile->ReadInteger("Color", "Color_Body"  , DEF_COL_Body  );
	Col_Knob    = (TColor)iniFile->ReadInteger("Color", "Color_Knob"  , DEF_COL_Knob  );
	Col_Bezel   = (TColor)iniFile->ReadInteger("Color", "Color_Bezel" , DEF_COL_Bezel );
	Col_Screen  = (TColor)iniFile->ReadInteger("Color", "Color_Screen", DEF_COL_Screen);
	Col_Grid    = (TColor)iniFile->ReadInteger("Color", "Color_Grid"  , DEF_COL_Grid  );

	SetColor();

	delete iniFile;
}



//---------------------------------------------------------------------------
// ini t@C̏
//---------------------------------------------------------------------------
void __fastcall TForm1::WriteIniFile(AnsiString path, bool sw)
{
	TDateTime t;
	TIniFile *iniFile;
	TFontStyles a;

	iniFile = new TIniFile(path);

	iniFile->WriteInteger("Position" , "Left"  , Form1->Left  );
	iniFile->WriteInteger("Position" , "Top"   , Form1->Top   );
	iniFile->WriteBool   ("Position" , "Snap"  , CB_SNAP->Checked);
	if (sw) {
	    iniFile->WriteString("CommPort", "PortNo"    , ComboBox1   ->Text);
	    iniFile->WriteString("CommPort", "Baud"      , CB_Br1 ->Text);
	}

	iniFile->WriteInteger("Panel_Setting", "TM_Div"       , CB_TMDIV  -> ItemIndex);
	iniFile->WriteInteger("Panel_Setting", "V-Mode"       , CB_VMODE  -> ItemIndex);
	iniFile->WriteInteger("Panel_Setting", "Trig_Channel" , CB_TRG_CH -> ItemIndex);
	iniFile->WriteInteger("Panel_Setting", "Trig_Mode"    , CB_TRG_MD -> ItemIndex);
	iniFile->WriteInteger("Panel_Setting", "Trig_Edge"    , CB_TRG_EG -> ItemIndex);
	iniFile->WriteInteger("Panel_Setting", "Trig_Level"   , TB_TRGL   -> Position );
	iniFile->WriteInteger("Panel_Setting", "CH1_Range"    , CB_RNG1   -> ItemIndex);
	iniFile->WriteInteger("Panel_Setting", "CH2_Range"    , CB_RNG2   -> ItemIndex);
	iniFile->WriteInteger("Panel_Setting", "CH1_Position" , TB_OFS1   -> Position );
	iniFile->WriteInteger("Panel_Setting", "CH2_Position" , TB_OFS2   -> Position );
	iniFile->WriteInteger("Panel_Setting", "CH1_Gain"     , TB_GAIN1  -> Position );
	iniFile->WriteInteger("Panel_Setting", "CH2_Gain"     , TB_GAIN2  -> Position );

	iniFile->WriteInteger("Color", "Color_CH1Pen" , Col_CH1Pen);
	iniFile->WriteInteger("Color", "Color_CH2Pen" , Col_CH2Pen);
	iniFile->WriteInteger("Color", "Color_Body"   , Col_Body  );
	iniFile->WriteInteger("Color", "Color_Knob"   , Col_Knob  );
	iniFile->WriteInteger("Color", "Color_Bezel"  , Col_Bezel );
	iniFile->WriteInteger("Color", "Color_Screen" , Col_Screen);
	iniFile->WriteInteger("Color", "Color_Grid"   , Col_Grid  );


//	t = t.CurrentDateTime();
//	iniFile->WriteDateTime("Access", "LastAccess", t);

	delete iniFile;
}



//---------------------------------------------------------------------------
// e Color ݒ
//---------------------------------------------------------------------------
void __fastcall TForm1::SetColor(void)
{
	Panel_CH1_PEN    -> Color = Col_CH1Pen;
	Panel_CH2_PEN    -> Color = Col_CH2Pen;
	PanelCH1         -> Color = Col_CH1Pen;
	PanelCH2         -> Color = Col_CH2Pen;

	Panel_COL_BODY   -> Color = Col_Body;
	Form1            -> Color = Col_Body;

	Panel_COL_KNOB   -> Color = Col_Knob;
	GB_TRIG          -> Color = Col_Knob;
	GB_HOR           -> Color = Col_Knob;
	GB_VMODE         -> Color = Col_Knob;
	GB_CH1           -> Color = Col_Knob;
	GB_CH2           -> Color = Col_Knob;
	GB_MISC          -> Color = Col_Knob;

	// TrackBaar ̐FςȂ̂ŁDDD

	TB_TRGL  -> Frequency *= 2;    TB_TRGL  -> Frequency /= 2;
	TB_OFS1  -> Frequency *= 2;    TB_OFS1  -> Frequency /= 2;
	TB_GAIN1 -> Frequency *= 2;    TB_GAIN1 -> Frequency /= 2;
	TB_OFS2  -> Frequency *= 2;    TB_OFS2  -> Frequency /= 2;
	TB_GAIN2 -> Frequency *= 2;    TB_GAIN2 -> Frequency /= 2;

	Panel_COL_BEZEL  -> Color = Col_Bezel;
	PanelBezel       -> Color = Col_Bezel;

	Panel_COL_SCREEN -> Color = Col_Screen;
	Panel_COL_GRID   -> Color = Col_Grid;

	InitScreen(Image1);
	DispData(Image1);
	Invalidate();
}



//---------------------------------------------------------------------------
// wWiʏ\pj߂
//---------------------------------------------------------------------------
int __fastcall TForm1::ScaleX(int a)
{
	int rh;

	rh = SMP_X_WIDTH / 2;  if ( a < 0) rh = -rh;
	return (a * CRT_X_WIDTH + rh) / SMP_X_WIDTH;
}

//---------------------------------------------------------------------------
// xWiʏ\pj߂
//---------------------------------------------------------------------------
int __fastcall TForm1::ScaleY(int a)
{
	int rh;

	a -= SMP_Y_MIN;
	rh = SMP_Y_WIDTH / 2;  if (a < 0) rh = -rh;
	return CRT_Y_WIDTH - ((a * CRT_Y_WIDTH + rh) / SMP_Y_WIDTH);
}

//---------------------------------------------------------------------------
// \Aڐ
//---------------------------------------------------------------------------
void __fastcall TForm1::InitScreen(TImage *p)
{
	int i, j, a;

	if (CB_PILE -> Checked) return;

	p->Width  = CRT_X_WIDTH;
	p->Height = CRT_Y_WIDTH + 1;

	//--------------- wi --------------

	p->Canvas->Brush->Color = Col_Screen;
	p->Canvas->FillRect(Rect(0, 0, p->Width, p->Height));

	//------------ ڐ` ---------------

	p->Canvas->Pen->Color = Col_Grid;

	//--------------- w --------------------

	for (i = 0; i <=  10; i++) {
	    j = (i * (p->Width - 1)) / 10;
	    p->Canvas->MoveTo(j, 0);
	    p->Canvas->LineTo(j, p->Height);
	}
	a = (p->Height - 1) / 2;
	for (i = 0; i <=  50; i++) {
	    j = (i * (p->Width - 1)) / 50;
	    p->Canvas->MoveTo(j, a - 2);
	    p->Canvas->LineTo(j, a + 3);
	}

	//--------------- x --------------------

	for (i = 0; i <=   8; i++) {
	    j = (i * (p->Height - 1)) / 8;
	    p->Canvas->MoveTo(0, j);
	    p->Canvas->LineTo(p->Width - 1, j);
	}
	a = (p->Width - 1) / 2;
	for (i = 0; i <=  40; i++) {
	    j = (i * (p->Height - 1)) / 40;
	    p->Canvas->MoveTo(a - 2, j);
	    p->Canvas->LineTo(a + 3, j);
	}
}



//---------------------------------------------------------------------------
// Mꂽf[^i[
//---------------------------------------------------------------------------
void __fastcall TForm1::PutData(int n, int d)
{
	int x, ch;

	x = n >> 1;  ch = n & 0x01;
	if (x < SMP_X_WIDTH) {
	    if (ch == 0) { CH1_buf[x] = d;  CH1_putptr = x; }
	    else         { CH2_buf[x] = d;  CH2_putptr = x; }
	}
}


//---------------------------------------------------------------------------
// Mꂽf[^\
//---------------------------------------------------------------------------
void __fastcall TForm1::DispData(TImage *p)
{
	int x, nx;

	if      (CB_VMODE -> Text == "CH1" ) { CH1_ena = ON ;  CH2_ena = OFF; }
	else if (CB_VMODE -> Text == "CH2" ) { CH1_ena = OFF;  CH2_ena = ON;  }
	else if (CB_VMODE -> Text == "BOTH") { CH1_ena = ON ;  CH2_ena = ON;  }
	else                                 { CH1_ena = OFF;  CH2_ena = OFF; }

	if (CH1_ena) {
	    p->Canvas->Pen->Color = Col_CH1Pen;
        if (CB_HX5 -> Checked == true) { x = TB_HX5 -> Position; }
        else                           { x = 0;                  }
        nx = 0;
	    p->Canvas->MoveTo(ScaleX(nx), ScaleY(CH1_buf[x]));
	    for ( ; x < CH1_putptr; x++) {
            if (nx > SMP_X_WIDTH) break;
	        p->Canvas->LineTo(ScaleX(nx), ScaleY(CH1_buf[x]));
            if (CB_HX5->Checked == true) nx+=5;
            else                         nx++;
	    }
	}
	if (CH2_ena) {
	    p->Canvas->Pen->Color = Col_CH2Pen;
        if (CB_HX5 -> Checked == true) { x = TB_HX5 -> Position; }
        else                           { x = 0;                  }
        nx = 0;
	    p->Canvas->MoveTo(ScaleX(nx), ScaleY(CH2_buf[x]));
	    for ( ; x < CH2_putptr; x++) {
	        p->Canvas->LineTo(ScaleX(nx), ScaleY(CH2_buf[x]));
            if (nx > SMP_X_WIDTH) break;
            if (CB_HX5->Checked == true) nx+=5;
            else                         nx++;
	    }
	}
}






//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
	InitScreen(Image1);
	DispData(Image1);
}

//---------------------------------------------------------------------------
// ʕ`
//---------------------------------------------------------------------------
void __fastcall TForm1::DspScreen(void)
{
	InitScreen(Image1);
	DispData(Image1);
	Invalidate();
}

//---------------------------------------------------------------------------
// ʏ
//---------------------------------------------------------------------------
void __fastcall TForm1::ClrScreen(void)
{
	InitScreen(Image1);
	Invalidate();
}



//===========================================================================
// COM |[g̐ݒ肪ύXꂽAĂяo
//===========================================================================
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
	InitComPort(ON);
}

void __fastcall TForm1::CB_Br1Change(TObject *Sender)
{
	InitComPort(ON);
}





//***************************************************************************
//gWƂ RS-232CʐM
//***************************************************************************



//---------------------------------------------------------------------------
//gW֑M
//---------------------------------------------------------------------------
void __fastcall TForm1::unit_tx_job(void)
{
	BYTE buf[10], d;

	buf[0] = 0xff;          // t[Jn

	buf[1] = (BYTE)(0x80
	         | ((CB_RNG2 -> ItemIndex & 0x07) << 3)
	         |  (CB_RNG1 -> ItemIndex & 0x07)     );

	d = 0x80;
	if (CB_ACC1  -> Checked == true) d |= 0x01; /* AC Coupling */
	if (CB_ACC2  -> Checked == true) d |= 0x02; /* AC Coupling */
	buf[2] = d;

	buf[3] = (BYTE)(0x80 | (CB_TMDIV -> ItemIndex & 0x0f));

	d = 0x80;
	if (CB_TRG_CH -> ItemIndex   ) d |= 0x40;  // Trig/Channel
	if (CB_TRG_EG -> ItemIndex   ) d |= 0x20;  // Trig.Edge
	if (SingleTrigFlag == ON) {
	    SingleTrigFlag = OFF;   d |= 0x08;     // SingleTrig.Flag
	}
	d |= (BYTE)(CB_TRG_MD -> ItemIndex & 0x07); // Trig.Mode
	buf[4] = d;

	buf[5] = (BYTE)(TB_TRGL  -> Position);
	buf[6] = (BYTE)(TB_OFS1  -> Max - TB_OFS1  -> Position);	/* 0 ` 200 */
	buf[7] = (BYTE)(TB_OFS2  -> Max - TB_OFS2  -> Position);
	buf[8] = (BYTE)(TB_GAIN1 -> Max - TB_GAIN1 -> Position);	/* 0 ` 150 */
	buf[9] = (BYTE)(TB_GAIN2 -> Max - TB_GAIN2 -> Position);

	buf[10] = 0x00;
	Ycom.sio_write((char *)buf, 11);
}





//---------------------------------------------------------------------------
//gWM
//---------------------------------------------------------------------------
void __fastcall TForm1::unit_rx_job(void)
{
	static int n, holdf = OFF;
	BYTE c;
	int a, i;

	if (CB_HOLD -> Checked == false) holdf = OFF;
	for (i = 0; i < 550; i++) {
	    if ((a = Ycom.sio_in()) == RX_EMPTY) break;
	    if ((c = (BYTE)a) == 0xff) {
	        n = 0; CT_td = 50;
	        if (CB_HOLD -> Checked == true) holdf = ON;
	        continue;
	    }
	    a = c;  a -= 128;
	    if (holdf == OFF) PutData(n++, a);
	    CTcut = CUT_TM;	  // ʐMՒfo
	    if (c == 0) {
	        DspScreen();
	        break;
	    }
	}
}





//===========================================================================
//ĂяogWʐM
//===========================================================================
void __fastcall TForm1::unit_job(void)
{
	unit_rx_job();

	if (CT_tx == 0) {
	    CT_tx = TX_TIM;	// 莞ԂƂ
	    unit_tx_job();	// ݒ𑗐M
	}

	if ((CTcut == 0)   	// ʐMՒfoԂ߂ꍇ
         && (CB_TRG_MD -> ItemIndex != 2)	// VOEgKłȂ
	 && (CB_HOLD -> Checked == false)) {	// z[hłȂꍇ
	    CH1_putptr = CH2_putptr = 0;	// S\NA
	    ClrScreen();
	}

}





//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//^C}ECxgnh
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	int n_t, past_ms;
	static int o_t;

	//-------- 1[mS] ŃfNgJE^ -------

	n_t = GetTickCount();  past_ms = n_t - o_t;  o_t = n_t;

	if (CTcut) { CTcut -= past_ms;  if (CTcut < 0) CTcut = 0; }
	if (CT_tx) { CT_tx -= past_ms;  if (CT_tx < 0) CT_tx = 0; }
	if (CT_td) { CT_td -= past_ms;  if (CT_td < 0) CT_td = 0; }

	//---------------- Trig.D \ --------------------

	if (CT_td) RB_TRGD -> Checked = true;	// Trig.D \
	else       RB_TRGD -> Checked = false;

	if (CB_TRG_MD -> ItemIndex == 2) PB_RES -> Visible = True;
	else                             PB_RES -> Visible = False;

    //------------------- Hor.X5 ----------------------

    if (CB_HX5 -> Checked == true) TB_HX5 -> Visible = true;
    else                           TB_HX5 -> Visible = false;

	//------------- gWƂ̒ʐMIV` ----------

	unit_job();
	if ((CB_TMDIV -> ItemIndex & 0x0f) >= 7) { /* 100[mS]/DIV ȏ */
	    DspScreen();				/* ĕ` */
	}
}



//===========================================================================
// CH1 Position Zero Button
//===========================================================================
void __fastcall TForm1::PB_Z1Click(TObject *Sender)
{
	TB_OFS1  -> Position = TB_OFS1  -> Max / 2;
	TB_GAIN1 -> Position = TB_GAIN1 -> Max;
	PanelBezel->SetFocus();     //Ij
}
//===========================================================================
// CH2 Position Zero Button
//===========================================================================
void __fastcall TForm1::PB_Z2Click(TObject *Sender)
{
	TB_OFS2  -> Position = TB_OFS2  -> Max / 2;
	TB_GAIN2 -> Position = TB_GAIN2 -> Max;
	PanelBezel->SetFocus();     //Ij
}

//===========================================================================
// Single Trig Button
//===========================================================================
void __fastcall TForm1::PB_RESClick(TObject *Sender)
{
	ClrScreen();
	SingleTrigFlag = ON;
	PanelBezel->SetFocus();     //Ij
}
//===========================================================================
// Trig ModeύXꂽ
//===========================================================================
void __fastcall TForm1::CB_TRG_MDChange(TObject *Sender)
{
	if (CB_TRG_MD -> Text == "SINGLE") {
	    ClrScreen();
	}
}
//---------------------------------------------------------------------------
// SetUp Button
//---------------------------------------------------------------------------
void __fastcall TForm1::PB_SETTINGClick(TObject *Sender)
{
	if (Panel1 -> Visible == false) {
	    Panel1 -> Visible = true;
	    PB_SETTING -> Caption = "Close SetUp";
	}
	else {
	    Panel1 -> Visible = false;
	    PB_SETTING -> Caption = "Open SetUp";
	}
	PanelBezel->SetFocus();     //Ij
}

//---------------------------------------------------------------------------
// Default Color Button
//---------------------------------------------------------------------------
void __fastcall TForm1::PB_COL_DEFClick(TObject *Sender)
{
	if (MessageBox(NULL,
	               "     Are You Sure ?",
	               " Set the Default Color.",
	               MB_OKCANCEL) == IDOK) {

	    Col_CH1Pen = DEF_COL_CH1Pen;
	    Col_CH2Pen = DEF_COL_CH2Pen;
	    Col_Body   = DEF_COL_Body;
	    Col_Knob   = DEF_COL_Knob;
	    Col_Bezel  = DEF_COL_Bezel;
	    Col_Screen = DEF_COL_Screen;
	    Col_Grid   = DEF_COL_Grid;

	    SetColor();
	}
}
//---------------------------------------------------------------------------
// CH1 Color Button
//---------------------------------------------------------------------------
void __fastcall TForm1::PB_COL_CH1Click(TObject *Sender)
{
	ColorDialog1->Color = Col_CH1Pen;
	if (ColorDialog1->Execute() == true) {
	    Col_CH1Pen = ColorDialog1->Color;
	    SetColor();
	}
}
//---------------------------------------------------------------------------
// CH2 Color Button
//---------------------------------------------------------------------------
void __fastcall TForm1::PB_COL_CH2Click(TObject *Sender)
{
	ColorDialog1->Color = Col_CH2Pen;
	if (ColorDialog1->Execute() == true) {
	    Col_CH2Pen = ColorDialog1->Color;
	    SetColor();
	}
}

//---------------------------------------------------------------------------
// Body Color Button
//---------------------------------------------------------------------------
void __fastcall TForm1::PB_COL_BODYClick(TObject *Sender)
{
	ColorDialog1->Color = Col_Body;
	if (ColorDialog1->Execute() == true) {
	    Col_Body = ColorDialog1->Color;
	    SetColor();
	}
}
//---------------------------------------------------------------------------
// Knob Frame Color Button
//---------------------------------------------------------------------------
void __fastcall TForm1::PB_COL_KNOBClick(TObject *Sender)
{
	ColorDialog1->Color = Col_Knob;
	if (ColorDialog1->Execute() == true) {
	    Col_Knob = ColorDialog1->Color;
	    SetColor();
	}
}
//---------------------------------------------------------------------------
// Bezel Color Button
//---------------------------------------------------------------------------
void __fastcall TForm1::PB_COL_BEZELClick(TObject *Sender)
{
	ColorDialog1->Color = Col_Bezel;
	if (ColorDialog1->Execute() == true) {
	    Col_Bezel = ColorDialog1->Color;
	    SetColor();
	}
}
//---------------------------------------------------------------------------
// Screen Color Button
//---------------------------------------------------------------------------
void __fastcall TForm1::PB_COL_SCREENClick(TObject *Sender)
{
	ColorDialog1->Color = Col_Screen;
	if (ColorDialog1->Execute() == true) {
	    Col_Screen = ColorDialog1->Color;
	    SetColor();
	}
}
//---------------------------------------------------------------------------
// Grid Color Button
//---------------------------------------------------------------------------
void __fastcall TForm1::PB_COL_GRIDClick(TObject *Sender)
{
	ColorDialog1->Color = Col_Grid;
	if (ColorDialog1->Execute() == true) {
	    Col_Grid = ColorDialog1->Color;
	    SetColor();
	}
}

//---------------------------------------------------------------------------
// X5 Hor.Position
//---------------------------------------------------------------------------
void __fastcall TForm1::TB_HX5Change(TObject *Sender)
{
    DspScreen();
}

//---------------------------------------------------------------------------
// X5 CheckBox
//---------------------------------------------------------------------------

void __fastcall TForm1::CB_HX5Click(TObject *Sender)
{
    DspScreen();
}
//--------------------------------------------------
//@EBhEړ̉ʒ[Xibv
//--------------------------------------------------
#define SNAP_WID 20
void __fastcall TForm1::Snap(void)
{
	int sw, sh, x0, x1, xw, y0, y1, yw;

	if ((CreateFlag == true) && (CB_SNAP->Checked == true)) {
	    sw = Screen->Width;  sh = Screen->Height;
	    x0 = Form1->Left;  xw = Form1->Width ;  x1 = x0 + xw;
	    y0 = Form1->Top ;  yw = Form1->Height;  y1 = y0 + yw;

	    if ((x0 <  0) || ( x0       < SNAP_WID)) Form1->Left = 0;
	    if ((x1 > sw) || ((sw - x1) < SNAP_WID)) Form1->Left = sw - xw;
	    if ((y0 <  0) || ( y0       < SNAP_WID)) Form1->Top  = 0;
	    if ((y0 > sh) || ((sh - y1) < SNAP_WID)) Form1->Top  = sh - yw;
	}
}
//--------------------------------------------------
//@tH[ړATCYύXI
//--------------------------------------------------
void __fastcall TForm1::FormExitSizeMove(TMessage &Message)
{
	Snap();
	Message.Result = 0;		// 0ԂƁB
}
//--------------------------------------------------
//@Snap CheckBox NbNꂽ
//--------------------------------------------------
void __fastcall TForm1::CB_SNAPClick(TObject *Sender)
{
    Snap();    
}
