//****************************************************
//bnl|[gNX\bhiWin32 System Servicesj
//      comport.cpp     Ver 1.11        2003,05,21
//****************************************************

#include <windows.h>
#include <stdio.h>		// vsprintf, EOF
#include <string.h>		// str...

#include "comport.h"

// DCB  2rbgtB[h萔`iwinbase.hj
// DTR Control Flow Values.(for Dcb.fDtrControl)
//    #define DTR_CONTROL_DISABLE    0x00
//    #define DTR_CONTROL_ENABLE     0x01
//    #define DTR_CONTROL_HANDSHAKE  0x02
//
// RTS Control Flow Values.(for Dcb.fRtsControl)
//    #define RTS_CONTROL_DISABLE    0x00
//    #define RTS_CONTROL_ENABLE     0x01
//    #define RTS_CONTROL_HANDSHAKE  0x02
//    #define RTS_CONTROL_TOGGLE     0x03
// 
// RTS/CTSt[I
//    Dcb.fOutxCtsFlow = TRUE;
//    Dcb.fRtsControl = RTS_CONTROL_HANDSHAKE;
// DTR/DSTt[I
//    Dcb.fOutxDsrFlow = TRUE;
//    Dcb.fDtrControl = DTR_CONTROL_HANDSHAKE;
//
// (Dcb.Parity)
//    #define NOPARITY            0
//    #define ODDPARITY           1
//    #define EVENPARITY          2
//    #define MARKPARITY          3
//    #define SPACEPARITY         4
//
// (Dcb.StopBits)
//    #define ONESTOPBIT          0
//    #define ONE5STOPBITS        1
//    #define TWOSTOPBITS         2

#define XON_CHAR     0x11	// MĂ
#define XOFF_CHAR    0x13	// M܂Ă

//====================================================
//DCB ݒ荀ڂP̑MԂ߂
// AlFP̑MԁmʂnP
//====================================================
DWORD __fastcall CommCtrl::sio_get_upc(void)
{
	DWORD n;

	n =  Dcb.ByteSize + (Dcb.Parity != NOPARITY) + (Dcb.StopBits != ONESTOPBIT) + 2;
	n *= 1000000L;
	if (Dcb.BaudRate) return n / Dcb.BaudRate;
	else              return 4000L;		// 4[mS]:2400[bps] 
}

//====================================================
//bnl̂LȂbnl|[g`FbN
//====================================================
bool __fastcall CommCtrl::IsValidComName(const char *ComName)
{

	char buf[2000];	// ꂾΏ\낤
	DWORD configSize = sizeof(buf);
	COMMCONFIG* config = (COMMCONFIG*) buf;

	memset(config, 0, configSize);
	return 	GetDefaultCommConfig(ComName, config, &configSize);
}
//====================================================
//bnl|[g̃G[NA
//====================================================
bool __fastcall CommCtrl::ClearCommErrors(void)
{
	DWORD Errors;

	if (ComHandle != INVALID_HANDLE_VALUE) {
	    ClearCommError(ComHandle, &Errors, NULL);
	    MessageBeep(0);
	}
	return false;
}
//====================================================
//f̃Rg[ WX^̒l擾
//====================================================
DWORD __fastcall CommCtrl::sio_get_stat(void)
{
	DWORD stat = 0;

	if (ComHandle != INVALID_HANDLE_VALUE) {
	    GetCommModemStatus(ComHandle, &stat);
	}
	return stat;
}

//====================================================
//bnl|[g̐ݒ
//====================================================
bool __fastcall CommCtrl::SetComName(const char *ComName)
{
	char s[11];

	strncpy(s, ComName, 10);
	strcpy(P_ComName, "\\\\.\\");  strcat(P_ComName, s);
	return true;
}
//====================================================
//{[[g̐ݒ
//====================================================
bool __fastcall CommCtrl::SetComBaudRate   (DWORD       BaudRate)
{
	P_BaudRate = BaudRate;
	return true;
}
bool __fastcall CommCtrl::SetComBaudRateStr(const char *BaudRate)
{
	P_BaudRate = atoi(BaudRate);
	return true;
}
//====================================================
//oCgTCY̐ݒ
//====================================================
bool __fastcall CommCtrl::SetComByteSize   (BYTE        ByteSize)
{
	P_ByteSize = ByteSize;
	return true;
}
bool __fastcall CommCtrl::SetComByteSizeStr(const char *ByteSize)
{
	BYTE bytesize;

	bytesize = (byte)atoi(ByteSize);
	switch (bytesize) {
	    case 4:
	    case 7:
	    case 8:  P_ByteSize = bytesize;  return true;
	    default:                         return false;
	}
}
//====================================================
//peB̐ݒ
//====================================================
bool __fastcall CommCtrl::SetComParity   (BYTE        Parity)
{
	P_Parity = Parity;
	return true;
}
bool __fastcall CommCtrl::SetComParityStr(const char *Parity)
{
	bool retcd = false;

	P_Parity = NOPARITY;
	if      (strnicmp(Parity, "NONE"  , 8) == 0) { P_Parity =    NOPARITY;  retcd = true; }
	else if (strnicmp(Parity, "ODD"   , 8) == 0) { P_Parity =   ODDPARITY;  retcd = true; }
	else if (strnicmp(Parity, "EVEN"  , 8) == 0) { P_Parity =  EVENPARITY;  retcd = true; }
	else if (strnicmp(Parity, "MARK"  , 8) == 0) { P_Parity =  MARKPARITY;  retcd = true; }
	else if (strnicmp(Parity, "SPACE" , 8) == 0) { P_Parity = SPACEPARITY;  retcd = true; }
	return retcd;
}
//====================================================
//Xgbvrbg̐ݒ
//====================================================
bool __fastcall CommCtrl::SetComStopBits   (BYTE        StopBits)
{
	P_StopBits = StopBits;
	return true;
}
bool __fastcall CommCtrl::SetComStopBitsStr(const char *StopBits)
{
	BYTE stopbits = ONESTOPBIT;
	bool retcd = false;

	if      (strnicmp(StopBits, "1"  , 5) == 0) { stopbits = ONESTOPBIT;    retcd = true; }
	else if (strnicmp(StopBits, "1.5", 5) == 0) { stopbits = ONE5STOPBITS;  retcd = true; }
	else if (strnicmp(StopBits, "2"  , 5) == 0) { stopbits = TWOSTOPBITS;   retcd = true; }
	P_StopBits = stopbits;
	return retcd;
}
//====================================================
//M XON/OFFt[̐ݒ
//====================================================
bool __fastcall CommCtrl::SetComTxXflow    (bool        FlowSw)
{
	P_XflowTx = FlowSw;
	return true;
}
//====================================================
//M XON/OFFt[̐ݒ
//====================================================
bool __fastcall CommCtrl::SetComRxXflow    (bool        FlowSw)
{
	P_XflowRx = FlowSw;
	return true;
}

//====================================================
//XON/OFFLN^̐ݒ
//====================================================
bool __fastcall CommCtrl::SetComXonChar    (char        c)
{
	P_XonChar = c;
	return true;
}
bool __fastcall CommCtrl::SetComXoffChar   (char        c)
{
	P_XoffChar = c;
	return true;
}

//====================================================
//ʐM|[gI[v
//AlFFtrueAG[Ffalse
//====================================================
bool __fastcall CommCtrl::sio_open(void)
{
	Success = false;
	ComHandle = CreateFile(
	    P_ComName,                       // name               Jt@C̖O
	    GENERIC_READ | GENERIC_WRITE,    // accessMode         Read/Write[h
	    0,                               // shareMode          t@CL@
	    NULL,                            // securityAttributes è\̂̃AhX
	    OPEN_EXISTING,                   // create             t@C@
	    FILE_ATTRIBUTE_NORMAL,           // attributes         ʏ̃t@C̑rbg
	    NULL                             // templateFile       g̓t@C
	);

	if (ComHandle != INVALID_HANDLE_VALUE) {
	    Success = GetCommState(ComHandle, &Dcb);
	    if (Success == true) {
	        Dcb.BaudRate          = P_BaudRate;
	        Dcb.ByteSize          = P_ByteSize;
	        Dcb.Parity            = P_Parity;
	        Dcb.StopBits          = P_StopBits;
	        Dcb.XonChar           = P_XonChar;    // TxRxXON i0x11 MĂj
	        Dcb.XoffChar          = P_XoffChar;   // TxRxXOFFi0x13 M҂ălj
	        Dcb.ErrorChar         = '?';          // G[
	        Dcb.EofChar           = 0x00;         // ͕̍Ō
	        Dcb.EvtChar           = 0x00;         // Cxg̎M

	        Dcb.fBinary           = true;         // 1bit oCi[hAEOF `FbNȂ
	        Dcb.fParity = Dcb.Parity != NOPARITY; // 1bit peB`FbNCl[u
	        Dcb.fOutxCtsFlow      = false;        // 1bit CTS o̓t[
	        Dcb.fOutxDsrFlow      = false;        // 1bit DSR o̓t[
	        Dcb.fDtrControl = DTR_CONTROL_ENABLE; // 2bit DTR t[^Cv
	        Dcb.fDsrSensitivity   = false;        // 1bit DSR ZVre
	        Dcb.fTXContinueOnXoff = true;         // 1bit XOFFTxp
	        Dcb.fOutX             = P_XflowTx;    // 1bit XON/OFF o̓t[
	        Dcb.fInX              = P_XflowRx;    // 1bit XON/OFF ̓t[
	        Dcb.fErrorChar        = false;        // 1bit ParityErrorErrorCharŒu
	        Dcb.fNull             = false;        // 1bit NULLoCgp
	        Dcb.fRtsControl = RTS_CONTROL_ENABLE; // 2bit RTS t[
	        Dcb.fAbortOnError     = false;        // 1bit G[Ǎ^o~

	        Success = SetCommState(ComHandle, &Dcb);
	    }
	    if (Success == true) {
	        timeouts.ReadIntervalTimeout         = MAXDWORD;
	        timeouts.ReadTotalTimeoutMultiplier  = 0;
	        timeouts.ReadTotalTimeoutConstant    = 0;
	        timeouts.WriteTotalTimeoutMultiplier = 1 + (sio_get_upc() / 1000);
	        timeouts.WriteTotalTimeoutConstant   = 500;
	        Success = SetCommTimeouts(ComHandle, &timeouts);
	    }
	    if (Success == true) {
	        Success = EscapeCommFunction(ComHandle, SETDTR);	// DTR ON
	    }
	    if (Success == true) {
	        Success = EscapeCommFunction(ComHandle, SETRTS);	// RTS ON
	    }
	}
	return Success;
}
//====================================================
//ʐM|[gN[Y
//====================================================
void __fastcall CommCtrl::sio_close(void)
{
	if (Success == true) {
	    EscapeCommFunction(ComHandle, CLRDTR);
	    EscapeCommFunction(ComHandle, CLRRTS);
	    Success = false;
	}
	if (ComHandle != INVALID_HANDLE_VALUE) {
	    CloseHandle(ComHandle);
	    ComHandle =  INVALID_HANDLE_VALUE;
	}
}
//====================================================
//ʐM|[gւPo
//====================================================
int __fastcall CommCtrl:: sio_putch(int c)
{
	DWORD numWrite;
	char str[2];
	int retcd = EOF;

	if (Success == true) {
	    str[0] = (char)c;  str[1] = '\0';
	    if (WriteFile(ComHandle, str, 1, &numWrite, 0) == true) {
	        if (numWrite == 1) retcd = c & 0xff;
	    }
	}
	return retcd;
}
//====================================================
//ʐM|[g֎w蕶o
//====================================================
DWORD __fastcall CommCtrl:: sio_write(const char *str, DWORD no)
{
	DWORD numWrite;

	if (Success == true) {
	    WriteFile(ComHandle, str, no, &numWrite, 0);
	}
	return numWrite;
}
//====================================================
//ʐM|[g֕o
//====================================================
int __fastcall CommCtrl:: sio_puts(const char *str)
{
	DWORD numWrite;
	int retcd = EOF;

	if (Success == true) {
	    if (WriteFile(ComHandle, str, strlen(str), &numWrite, 0) == true) {
	        retcd = numWrite;
	    }
	}
	return retcd;
}
//====================================================
//ʐM|[gւ
//====================================================
int __fastcall CommCtrl::sio_printf(const char *f, void *_ap)
{
	char a[256];
	int n;
	va_list ap;

	va_start(ap, f);
	n = vsprintf(a, f, ap);
	if (sio_puts(a) == EOF) return EOF;
	return n;
}
//====================================================
//ʐM|[gP
//MĂ΁@Mf[^iint 0`255  jԂ
//M@@Ȃ΁@@@@@@iint RX_EMPTYjԂ
//====================================================
int __fastcall CommCtrl::sio_in(void)
{
	DWORD numRead;
	char str[100];
	int retcd = RX_EMPTY;

	if (Success == true) {
	    if (ReadFile(ComHandle, str, 1, &numRead, 0) == true) {
	        if (numRead) retcd = str[0] & 0xff;
	    }
	}
	return retcd;
}
//====================================================
//ʐM|[gw蕶ȓœ
//AlFMꂽ
//====================================================
DWORD __fastcall CommCtrl::sio_read(char *buf, DWORD no)
{
	DWORD numRead;

	if (Success == true) {
	    if (ReadFile(ComHandle, buf, no, &numRead, 0) == true) return numRead;
	}
	return 0;
}
//====================================================
//qsȑo
//@F0=OFF, 1=ON
//====================================================
bool __fastcall CommCtrl::sio_set_rts(int sw)
{
	if (Success == false) return false;
	if (sw) return EscapeCommFunction(ComHandle, SETRTS);
	else    return EscapeCommFunction(ComHandle, CLRRTS);
}

//====================================================
//csq̏o
//@F0=OFF, 1=ON
//====================================================
bool __fastcall CommCtrl::sio_set_dtr(int sw)
{
	if (Success == false) return false;
	if (sw) return EscapeCommFunction(ComHandle, SETDTR);
	else    return EscapeCommFunction(ComHandle, CLRDTR);
}

//====================================================
//Mobt@̃NA
//====================================================
bool __fastcall CommCtrl::sio_rx_clr(void)
{
	if (Success == false) return false;
	return PurgeComm(ComHandle, PURGE_RXCLEAR);
}

//====================================================
//RXgN^
//====================================================
__fastcall CommCtrl::CommCtrl(void)
{
	SetComName    ();
	SetComBaudRate();
	SetComByteSize();
	SetComParity  ();
	SetComStopBits();
	SetComTxXflow ();
	SetComRxXflow ();
	ComHandle = INVALID_HANDLE_VALUE;
	Success   = false;
}
